// Copyright (C) 2012 MicroStrain, Inc.

// 2400_sdkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "2400_sdk.h"
#include "2400_sdkDlg.h"
#include ".\2400_sdkdlg.h"

/*	references all serial (comm) port functionality	*/
#include "serial.h"
/*	references all base station functionality	*/
#include "base_station.h"
/*	references all node functionality	*/
#include "node.h"
/*	functions used for writing to the console	*/
#include "console_commands.h"
extern CMapPosToCString strCmd_info;
extern CMapPosToColor crCmd_color;
/*	used when the user clicks the stream setup button	*/
#include "streamsetup.h"
/*	used when the user performs a low duty cycle to allow them to stop the low duty cycle monitor.	*/
#include "progresswnd.h"
/*	create a c-style array at runtime that cleans itself up.	*/
#include "dynamic_buffer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CsdkDlg dialog



CsdkDlg::CsdkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CsdkDlg::IDD, pParent),
	m_iBaudRate(CBR_921600)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CsdkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPIN_PORT, m_csbcPort);
	DDX_Control(pDX, IDC_EDIT_PORT, m_cePort);
	DDX_Control(pDX, IDC_LIST_CONSOLE, m_clbConsole);
	DDX_Control(pDX, IDC_SPIN_EEPROM_LOCATION, m_csbcBase_eeprom_location);
	DDX_Control(pDX, IDC_SPIN_EEPROM_VALUE, m_csbcBase_eeprom_value);
	DDX_Control(pDX, IDC_SPIN_ND_EEPROM_LOCATION2, m_csbcNode_eeprom_location);
	DDX_Control(pDX, IDC_SPIN_ND_EEPROM_VALUE2, m_csbcNode_eeprom_value);
	DDX_Control(pDX, IDC_SPIN_NODE, m_csbcNode);
	DDX_Control(pDX, IDC_SPIN_ND_PAGE_DL, m_csbcPage);
	DDX_Control(pDX, IDC_SPIN_ND_TRIGGER, m_csbcTrigger);
	DDX_Control(pDX, IDC_EDIT_COMMAND_INFO, m_editCmd_info);
	DDX_Control(pDX, IDC_BAUD_CHECK, m_BaudCheck);
}

BEGIN_MESSAGE_MAP(CsdkDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_EN_KILLFOCUS(IDC_EDIT_PORT, OnEnKillfocusEditPort)
	ON_BN_CLICKED(IDC_BUTTON_BS_PING, OnBnClickedButtonPing)
	ON_EN_KILLFOCUS(IDC_EDIT_EEPROM_LOCATION, OnEnKillfocusEditEepromLocation)
	ON_EN_KILLFOCUS(IDC_EDIT_EEPROM_VALUE, OnEnKillfocusEditEepromValue)
	ON_BN_CLICKED(IDC_BUTTON_BS_READ_EEPROM, OnBnClickedButtonBsReadEeprom)
	ON_BN_CLICKED(IDC_BUTTON_BS_WRITE_EEPROM, OnBnClickedButtonBsWriteEeprom)
	ON_EN_KILLFOCUS(IDC_EDIT_ND_EEPROM_LOCATION, OnEnKillfocusEditNdEepromLocation)
	ON_EN_KILLFOCUS(IDC_EDIT_ND_EEPROM_VALUE, OnEnKillfocusEditNdEepromValue)
	ON_BN_CLICKED(IDC_BUTTON_ND_READ_EEPROM, OnBnClickedButtonNdReadEeprom)
	ON_EN_KILLFOCUS(IDC_EDIT_NODE, OnEnKillfocusEditNode)
	ON_BN_CLICKED(IDC_BUTTON_ND_PING, OnBnClickedButtonNdPing)
	ON_BN_CLICKED(IDC_BUTTON_ND_WRITE_EEPROM, OnBnClickedButtonNdWriteEeprom)
	ON_EN_KILLFOCUS(IDC_EDIT_ND_PAGE_DL, OnEnKillfocusEditNdPageDl)
	ON_BN_CLICKED(IDC_BUTTON_ND_DL_PAGE, OnBnClickedButtonNdDlPage)
	ON_EN_KILLFOCUS(IDC_EDIT_ND_TRIGGER, OnEnKillfocusEditNdTrigger)
	ON_BN_CLICKED(IDC_BUTTON_ND_TRIGGER, OnBnClickedButtonNdTrigger)
	ON_BN_CLICKED(IDC_BUTTON_ND_SLEEP, OnBnClickedButtonNdSleep)
	ON_BN_CLICKED(IDC_BUTTON_ND_ERASE, OnBnClickedButtonNdErase)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_CONSOLE_CLEAR, OnConsoleClear)
	ON_LBN_SELCHANGE(IDC_LIST_CONSOLE, OnLbnSelchangeListConsole)
	ON_BN_CLICKED(IDC_BUTTON_ND_STREAM_SETUP, OnBnClickedButtonNdStreamSetup)
	ON_BN_CLICKED(IDC_BUTTON_ND_STREAM, OnBnClickedButtonNdStream)
	ON_BN_CLICKED(IDC_BUTTON_ND_LONG_PING, OnBnClickedButtonNdLongPing)
	ON_BN_CLICKED(IDC_BUTTON_ND_LOW_DUTY_CYCLE, OnBnClickedButtonNdLowDutyCycle)
	ON_BN_CLICKED(IDC_BUTTON_ND_NODE_DISCOVERY, OnBnClickedButtonNdNodeDiscovery)
	ON_BN_CLICKED(IDC_BUTTON_ND_KILL, OnBnClickedButtonNdKill)
	ON_BN_CLICKED(IDC_BUTTON_ND_HS_STREAM, OnBnClickedButtonNdHsStream)
	ON_BN_CLICKED(IDC_BAUD_CHECK, &CsdkDlg::OnBnClickedBaudCheck)
	ON_BN_CLICKED(IDC_BUTTON_ND_SYNC_SAMPLING, &CsdkDlg::OnBnClickedButtonNdSyncSampling)
	ON_BN_CLICKED(IDC_BEACON_ENABLE_BTN, &CsdkDlg::OnBnClickedBeaconEnableBtn)
	ON_BN_CLICKED(IDC_BEACON_DISABLE_BTN, &CsdkDlg::OnBnClickedBeaconDisableBtn)
END_MESSAGE_MAP()

void CsdkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CsdkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CsdkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

/************************
*	OnInitDialog()
*	OnInitDialog() allows the initialization of dialog box
*	items used by the application.  See each command for a description
*	of what it does.
************************/
BOOL CsdkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	/*	give the console commands a reference to the output console	*/
	set_console(&m_clbConsole);

	/*	Set the port number to the low value by default	*/
	SetDlgItemInt(IDC_EDIT_PORT, PORT_NUM_LO);
	/*	Set the range for the port number's spin control	*/
	m_csbcPort.SetRange32(PORT_NUM_LO, PORT_NUM_HI);

	/*	Setup the base station group box information	*/
	UDACCEL udAccel;
	udAccel.nInc = 2;
	m_csbcBase_eeprom_location.SetAccel(1, &udAccel);
	m_csbcBase_eeprom_location.SetRange(EEPROM_LOCATION_LO, EEPROM_LOCATION_HI);
	m_csbcBase_eeprom_value.SetRange32(EEPROM_VALUE_LO, EEPROM_VALUE_HI);
	m_BaudCheck.SetCheck(BST_CHECKED);

	/*	Setup the node group box information	*/
	SetDlgItemInt(IDC_EDIT_NODE, NODE_ADDRESS_LO);
	m_csbcNode.SetRange32(NODE_ADDRESS_LO, NODE_ADDRESS_HI);
	m_csbcNode_eeprom_location.SetAccel(1, &udAccel);
	m_csbcNode_eeprom_location.SetRange(EEPROM_LOCATION_LO, EEPROM_LOCATION_HI);
	m_csbcNode_eeprom_value.SetRange32(EEPROM_VALUE_LO, EEPROM_VALUE_HI);
	m_csbcPage.SetRange32(NODE_PAGE_LO, NODE_PAGE_HI);
	m_csbcTrigger.SetRange(TRIGGER_ID_LO, TRIGGER_ID_HI);

	/*	Clear the console just in case there's anything in it	*/
	m_clbConsole.ResetContent();

	/*	Clear the command information window	*/
	m_editCmd_info.SetWindowText("");

	/*	Initialize the string hash table to something of relatively small, prime number	*/
	strCmd_info.InitHashTable(41);

	return TRUE;
}

/************************
*	OnBnClickedButtonPing()
*	OnBnClickedButtonPing() is called when the user selects the ping button in the
*	base station commands group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonPing()
{
	TRACE("CsdkDlg::OnBnClickedButtonPing()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);		//	read the port number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (bs_ping(hPort) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonBsReadEeprom()
*	OnBnClickedButtonBsReadEeprom() is called when the user selects the read eeprom
*	button in the base station group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonBsReadEeprom()
{
	TRACE("CsdkDlg::OnBnClickedButtonBsReadEeprom()\n");	
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);								//	read the port number
	unsigned char ucLocation = GetDlgItemInt(IDC_EDIT_EEPROM_LOCATION);		//	read the eeprom location
	HANDLE hPort;
	unsigned short usResponse;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (bs_eeprom_read(hPort, ucLocation, usResponse) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonBsWriteEeprom()
*	OnBnClickedButtonBsWriteEeprom() is called when the user selects the write eeprom
*	button in the base station group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonBsWriteEeprom()
{
	TRACE("CsdkDlg::OnBnClickedButtonBsWriteEeprom()\n");	
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);								//	read the port number
	unsigned char ucLocation = GetDlgItemInt(IDC_EDIT_EEPROM_LOCATION);		//	read the eeprom location
	unsigned short usValue = GetDlgItemInt(IDC_EDIT_EEPROM_VALUE);			//	read the eeprom value
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (bs_eeprom_write(hPort, ucLocation, usValue) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}


/************************
*	OnBnClickedButtonNdReadEeprom()
*	OnBnClickedButtonNdReadEeprom() is called when the user selects the read eeprom
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdReadEeprom()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdReadEeprom()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	int iLocation = GetDlgItemInt(IDC_EDIT_ND_EEPROM_LOCATION);		//	read the eeprom location
	unsigned short usResponse;
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_eeprom_read(hPort, iNode, iLocation, usResponse) != 0)
	{
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
	{
		return;
	}
}

/************************
*	OnBnClickedButtonNdWriteEeprom()
*	OnBnClickedButtonNdWriteEeprom() is called when the user selects the write eeprom
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdWriteEeprom()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdReadEeprom()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	int iLocation = GetDlgItemInt(IDC_EDIT_ND_EEPROM_LOCATION);		//	read the eprom location
	int iValue = GetDlgItemInt(IDC_EDIT_ND_EEPROM_VALUE);			//	read teh eeprom value
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_eeprom_write(hPort, iNode, iLocation, iValue) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;	
}

/************************
*	OnBnClickedButtonNdPing()
*	OnBnClickedButtonNdPing() is called when the user selects the ping
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdPing()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdReadEeprom()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_ping(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdDlPage()
*	OnBnClickedButtonNdDlPage() is called when the user selects the page download
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdDlPage()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdDlPage()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	int iPage = GetDlgItemInt(IDC_EDIT_ND_PAGE_DL);					//	read the page to download
	unsigned short usResponse[132];
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_page_download(hPort, iNode, iPage, usResponse) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdTrigger()
*	OnBnClickedButtonNdTrigger() is called when the user selects the trigger
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdTrigger()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdTrigger()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	int iID = GetDlgItemInt(IDC_EDIT_ND_TRIGGER);					//	read the trigger id
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_trigger(hPort, iNode, iID) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdSleep()
*	OnBnClickedButtonNdSleep() is called when the user selects the sleep
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdSleep()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdSleep()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_sleep(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdErase()
*	OnBnClickedButtonNdErase() is called when the user selects the erase
*	button in the node group box.  Please, investigate the implementation of each
*	individual function for a better understanding of each command.
************************/
void CsdkDlg::OnBnClickedButtonNdErase()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdErase()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_erase(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdStream()
*	OnBnClickedButtonNdStream() initiates a stream on a node.
************************/
void CsdkDlg::OnBnClickedButtonNdStream()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdStream()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	int iResult;					//	return value of port read/write functions
	unsigned short usChannel_mask;				//	holds the channel mask
	unsigned char ucNum_channels = 0;			//	holds the number of active channels
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if ((iResult = nd_eeprom_read(hPort, iNode, EE_CHANNEL_MASK, usChannel_mask)) != 0) {
		port_close(hPort);
		return;
	}

	/*	calculate the number of active channels	*/
	for (int i = 0; i < 8; i++)	//	iterate through every channel button to test if it's checked
		if ((usChannel_mask >> i) & 1)
			ucNum_channels++;

	if ((iResult = nd_stream_init(hPort, iNode)) != 0) {
		port_close(hPort);
		return;
	}

	dynamic_buffer<unsigned short> usResponse(ucNum_channels);

	CProgressWnd pwProgress(this, "Streaming Data", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Streaming data from node");
	pwProgress.GoModal();

	do
	{
		iResult = nd_stream_sweep(hPort, usResponse, ucNum_channels);
		pwProgress.PeekAndPump();
		//AfxGetApp()->PumpMessage();
	} while (!pwProgress.Cancelled() && iResult == 0);

	if (port_close(hPort) != 0)
		return;
}

/************************
*	OnBnClickedButtonNdStreamSetup()
*	OnBnClickedButtonNdStreamSetup() pops up a small streaming setup window for the
*	user to set the channel mask and number of sweeps.  This data is then written
*	to the corresponding node on the corresponding port.
*	PRE:	the port number and node address are set correctly on the dialog window.
*	POST:	if the user selected the write button on the setup window, the data has
*			been written to the node.
************************/
void CsdkDlg::OnBnClickedButtonNdStreamSetup()
{
	CStreamSetup dlgStream;
	if (dlgStream.DoModal() == IDOK) {
		/*	the user selected zero so continue to write data to the node	*/
		int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
		int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
		HANDLE hPort;
		int iReturn;

		if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
			return;

		/*	make sure the base station works	*/
		if ((iReturn = bs_ping(hPort)) != 0) {
			port_close(hPort);
			return;
		}

		/*	make sure the node is available	*/
		if ((iReturn = nd_ping(hPort, iNode)) != 0) {
			port_close(hPort);		
			return;
		}
		
		/*	write the channel mask	*/
		unsigned short usRead_mask;
		do {
			/*	write the data	*/
			if ((iReturn = nd_eeprom_write(hPort, iNode, EE_CHANNEL_MASK, dlgStream.m_usChannel_mask)) != 0) {
				port_close(hPort);
				return;
			}
			/*	confirm the write	*/
			if ((iReturn = nd_eeprom_read(hPort, iNode, EE_CHANNEL_MASK, usRead_mask)) != 0) {
				port_close(hPort);
				return;
			}
		} while (dlgStream.m_usChannel_mask != usRead_mask);

		/* write the continuous streaming flag */
		unsigned short usWrite_continuous = dlgStream.m_bContinuous_streaming?CONTINUOUS_ENABLED:CONTINUOUS_DISABLED;
		unsigned short usRead_continuous;
		do {
			/*	write the data	*/
			if ((iReturn = nd_eeprom_write(hPort, iNode, EE_CONTINUOUS_STREAMING, usWrite_continuous)) != 0) {
				port_close(hPort);
				return;
			}
			/*	confirm the write	*/
			if ((iReturn = nd_eeprom_read(hPort, iNode, EE_CONTINUOUS_STREAMING, usRead_continuous)) != 0) {
				port_close(hPort);
				return;
			}
		} while (usWrite_continuous != usRead_continuous);


		/*	write the number of sweeps if continuous streaming is disabled	*/
		if(!dlgStream.m_bContinuous_streaming)
		{
			unsigned short usSweeps = dlgStream.m_usSweeps / 100,
							usRead_sweeps;
			do {
				/*	write the data	*/
				if ((iReturn = nd_eeprom_write(hPort, iNode, EE_SAMPLES_PER_DATA_SET, usSweeps)) != 0) {
					port_close(hPort);
					return;
				}
				/*	confirm the data	*/
				if ((iReturn = nd_eeprom_read(hPort, iNode, EE_SAMPLES_PER_DATA_SET, usRead_sweeps)) != 0) {
					port_close(hPort);
					return;
				}
			} while (usSweeps != usRead_sweeps);
		}

		if (port_close(hPort) != 0)
			return;
	}
}

/************************
*	make_port_string()
*	make_port_string() is called to convert the integer value of a serial port
*	to the correct string format.
*	PRE:	uiPort is an unsigned integer port number
*	POST:	a correctly formatted CString object has been returned with the port's
*				number already in it.
************************/
CString CsdkDlg::make_port_string(unsigned int uiPort)
{
	CString strPort;
	strPort.Format("\\\\.\\COM%i", uiPort);
	return strPort;
}


/************************
*	OnEnKillfocusEditPort()
*	OnEnKillfocusEditPort() is called when the area the user enters the port number
*	at on the dialog box loses focus.  It is used to perform a range test.  If the
*	the port number is out of range, either greater than PORT_NUM_HI or lower than
*	PORT_NUM_LO, the item will be set to PORT_NUM_HI or PORT_NUM_LO depending on
*	which end of the range is most least broken.
************************/
void CsdkDlg::OnEnKillfocusEditPort()
{
	TRACE("CsdkDlg::OnEnKillfocusEditPort()\n");

	int iPort = GetDlgItemInt(IDC_EDIT_PORT);
	if (iPort < PORT_NUM_LO)
		SetDlgItemInt(IDC_EDIT_PORT, PORT_NUM_LO);
	if (iPort > PORT_NUM_HI)
		SetDlgItemInt(IDC_EDIT_PORT, PORT_NUM_HI);
}

/************************
*	OnEnKillfocusEditEepromLocation()
*	OnEnKillfocusEditEepromLocation() checks the range of the base stationeeprom location
*	when focus on the eeprom location edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditEepromLocation()
{
	TRACE("CsdkDlg::OnEnKillfocusEditEepromLocation()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_EEPROM_LOCATION);
	if (iValue < EEPROM_LOCATION_LO)
		SetDlgItemInt(IDC_EDIT_EEPROM_LOCATION, EEPROM_LOCATION_LO);
	if (iValue > EEPROM_LOCATION_HI)
		SetDlgItemInt(IDC_EDIT_EEPROM_LOCATION, EEPROM_LOCATION_HI);
}

/************************
*	OnEnKillfocusEditEepromValue()
*	OnEnKillfocusEditEepromValue() checks the range of the base station eeprom value
*	when focus on the eeprom value edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditEepromValue()
{
	TRACE("CsdkDlg::OnEnKillfocusEditEepromValue()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_EEPROM_VALUE);
	if (iValue < EEPROM_VALUE_LO)
		SetDlgItemInt(IDC_EDIT_EEPROM_VALUE, EEPROM_VALUE_LO);
	if (iValue > EEPROM_VALUE_HI)
		SetDlgItemInt(IDC_EDIT_EEPROM_VALUE, EEPROM_VALUE_HI);
}

/************************
*	OnEnKillfocusEditNdEepromLocation()
*	OnEnKillfocusEditNdEepromLocation() checks the range of the node eeprom location
*	when focus on the eeprom location edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditNdEepromLocation()
{
	TRACE("CsdkDlg::OnEnKillfocusEditNdEepromLocation()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_ND_EEPROM_LOCATION);
	if (iValue < EEPROM_LOCATION_LO)
		SetDlgItemInt(IDC_EDIT_ND_EEPROM_LOCATION, EEPROM_LOCATION_LO);
	if (iValue > EEPROM_LOCATION_HI)
		SetDlgItemInt(IDC_EDIT_ND_EEPROM_LOCATION, EEPROM_LOCATION_HI);
}

/************************
*	OnEnKillfocusEditNdEepromValue()
*	OnEnKillfocusEditNdEepromValue() checks the range of the node eeprom value
*	when focus on the eeprom value edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditNdEepromValue()
{
	TRACE("CsdkDlg::OnEnKillfocusEditNdEepromValue()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_ND_EEPROM_VALUE);
	if (iValue < EEPROM_VALUE_LO)
		SetDlgItemInt(IDC_EDIT_ND_EEPROM_VALUE, EEPROM_VALUE_LO);
	if (iValue > EEPROM_VALUE_HI)
		SetDlgItemInt(IDC_EDIT_ND_EEPROM_VALUE, EEPROM_VALUE_HI);
}

/************************
*	OnEnKillfocusEditNode()
*	OnEnKillfocusEditNode() checks the range of the node'e address
*	when focus on the node's address edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditNode()
{
	TRACE("CsdkDlg::OnEnKillfocusEditNode()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_NODE);
	if (iValue < NODE_ADDRESS_LO)
		SetDlgItemInt(IDC_EDIT_NODE, NODE_ADDRESS_LO);
	if (iValue > NODE_ADDRESS_HI)
		SetDlgItemInt(IDC_EDIT_NODE, NODE_ADDRESS_HI);
}

/************************
*	OnEnKillfocusEditNdPageDl()
*	OnEnKillfocusEditNdPageDl() checks the range of the page to download
*	when focus on the page to download edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less tahn the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditNdPageDl()
{
	TRACE("CsdkDlg::OnEnKillfocusEditNdPageDl()\n");

	int iValue = GetDlgItemInt(IDC_EDIT_ND_PAGE_DL);
	if (iValue < NODE_PAGE_LO)
		SetDlgItemInt(IDC_EDIT_ND_PAGE_DL, NODE_PAGE_LO);
	if (iValue > NODE_PAGE_HI)
		SetDlgItemInt(IDC_EDIT_ND_PAGE_DL, NODE_PAGE_HI);
}

/************************
*	OnEnKillfocusEditNdTrigger()
*	OnEnKillfocusEditNdTrigger() checks the range of the trigger id
*	when focus on the trigger id edit box has lost focus.
*	PRE:	none
*	POST:	if the value in the edit control is greater than the maximum
*				range the value is adjusted to the maximum range value.  Likewise,
*				if the value in the edit control is less than the maximum
*				range the value is adjusted to the minimum range value.
************************/
void CsdkDlg::OnEnKillfocusEditNdTrigger()
{
	TRACE("CsdkDlg::OnEnKillfocusEditNdTrigger()\n");
	int iValue = GetDlgItemInt(IDC_EDIT_ND_TRIGGER);
	if (iValue < TRIGGER_ID_LO)
		SetDlgItemInt(IDC_EDIT_ND_TRIGGER, TRIGGER_ID_LO);
	if (iValue > TRIGGER_ID_HI)
		SetDlgItemInt(IDC_EDIT_ND_TRIGGER, TRIGGER_ID_HI);
}


/************************
*	OnHelpAbout()
*	OnHelpAbout() shows the about window
************************/
void CsdkDlg::OnHelpAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

/************************
*	OnConsoleClear()
*	OnConsoleClear() clears the console window
************************/
void CsdkDlg::OnConsoleClear()
{
	/*	reset the console	*/
	m_clbConsole.ResetContent();

	/*	erase all the strings	*/
	strCmd_info.RemoveAll();

	/*	erase all the colors	*/
	crCmd_color.RemoveAll();
}

/************************
*	OnLbnSelchangeListConsole()
*	OnLbnSelchangeListConsole() changes the command information box
*	to reflect the currently selected item in the console window.
************************/
void CsdkDlg::OnLbnSelchangeListConsole()
{
	try {
		/*	set the command info text associated with the selected command	*/
		m_editCmd_info.SetWindowText(strCmd_info[m_clbConsole.GetCurSel()]);
	} catch (...) {
		/*	if there's an error, we catch it, and just return.	*/
		m_editCmd_info.SetWindowText("No information provided for the selected command.");
		return;
	}
}

void CsdkDlg::OnBnClickedButtonNdLongPing()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdLongPing()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	if (nd_ping_long(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
		return;
}

void CsdkDlg::OnBnClickedButtonNdLowDutyCycle()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdLowDutyCycle()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;
	unsigned short usResponse;			//	holds the channel mask read from the EEPROM
	unsigned char ucNumChannels = 0;	//	number of active channels on the device

	CProgressWnd pwProgress(this, "Low Duty Cycle", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Waiting for low duty cycle packet");
	pwProgress.GoModal();

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	/*	The first read is only here so we know how many bytes to read for each low duty packet and
	*	to format the output of the received bytes nicer.  In a production worthy application, performing
	*	the read is unnecessary and some other means of stopping the applicaiton from receiving bytes
	*	should be done.	*/
	if (nd_eeprom_read(hPort, iNode, EE_CHANNEL_MASK, usResponse) != 0) {
		port_close(hPort);	
		return;
	}

	if (nd_low_duty_cycle_init(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}
	
	for (int i = 0; i < 8; i++)
		if ((usResponse >> i) & 1)
			ucNumChannels++;

	
	do
	{
		nd_low_duty_cycle_packet(hPort, ucNumChannels);
		pwProgress.PeekAndPump();
	} while (!pwProgress.Cancelled());


	if (port_close(hPort) != 0)
		return;
}

void CsdkDlg::OnBnClickedButtonNdNodeDiscovery()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdLowDutyCycle()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;
	
	CProgressWnd pwProgress(this, "Node Discovery", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Please, turn your desired node off and on again to view a discovery packet.");
	pwProgress.GoModal();

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	do
	{
		port_update_read_timeout(hPort, 1000);
		nd_discovery_packet(hPort);
		pwProgress.PeekAndPump();
	} while (!pwProgress.Cancelled());

	port_update_read_timeout(hPort);

	if (port_close(hPort) != 0)
		return;
}

void CsdkDlg::OnBnClickedButtonNdKill()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdKill()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;
	
	CProgressWnd pwProgress(this, "Stop Node", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Attempting to stop the node...");
	pwProgress.GoModal();

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	/* send the stop node to the base station */
	if (nd_kill_node_init(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}

	int iStatus;
	bool bNodeKilled;
	do
	{
		pwProgress.PeekAndPump();

		//if cancel was clicked abort the kill proccess, but only do it once
		if(pwProgress.Cancelled())
		{
			nd_kill_node_abort(hPort);
		}

		iStatus = nd_kill_node_status(hPort, bNodeKilled);
	} while (!pwProgress.Cancelled() && !bNodeKilled && iStatus==0);

	port_update_read_timeout(hPort);

	if (port_close(hPort) != 0)
		return;
}

void CsdkDlg::OnBnClickedButtonNdHsStream()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdHsStream()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;
	
	CProgressWnd pwProgress(this, "High Speed Stream", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Waiting for high speed packet");
	pwProgress.GoModal();

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
		return;

	// start HSS
	if (nd_high_speed_stream_init(hPort, iNode) != 0) {
		port_close(hPort);	
		return;
	}
	
	//read all packets
	int iResponse = 0;
	do
	{
		iResponse = nd_high_speed_stream_packet(hPort);
		pwProgress.PeekAndPump();
	} while (!pwProgress.Cancelled() && iResponse==0);


	if (port_close(hPort) != 0)
		return;
}

void CsdkDlg::OnBnClickedBaudCheck()
{
	if(m_BaudCheck.GetCheck() == BST_CHECKED)
	{
		m_iBaudRate = CBR_921600;
	}
	else
	{
		m_iBaudRate = CBR_115200;
	}
}

void CsdkDlg::OnBnClickedButtonNdSyncSampling()
{
	TRACE("CsdkDlg::OnBnClickedButtonNdSyncSampling()\n");
	int iPort = GetDlgItemInt(IDC_EDIT_PORT);						//	read the port number
	int iNode = GetDlgItemInt(IDC_EDIT_NODE);						//	read the node number
	HANDLE hPort;
	unsigned char ucNumChannels = 0;	//	number of active channels on the device

	CProgressWnd pwProgress(this, "Synchronized Sampling", TRUE);
	pwProgress.SetWindowSize(1);
	pwProgress.SetText("Waiting for synchronized sampling packet");
	pwProgress.GoModal();

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
	{
		return;
	}
	
	do
	{
		nd_sync_sampling_packet(hPort);
		pwProgress.PeekAndPump();
	} while (!pwProgress.Cancelled());


	if (port_close(hPort) != 0)
	{
		return;
	}
}

void CsdkDlg::OnBnClickedBeaconEnableBtn()
{
	TRACE("CsdkDlg::OnBnClickedBeaconEnableBtn()\n");

	int iPort = GetDlgItemInt(IDC_EDIT_PORT);								//	read the port number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
	{
		return;
	}

	if (bs_enable_beacon(hPort, true) != 0) 
	{
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
	{
		return;
	}
}

void CsdkDlg::OnBnClickedBeaconDisableBtn()
{
	TRACE("CsdkDlg::OnBnClickedBeaconDisableBtn()\n");

	int iPort = GetDlgItemInt(IDC_EDIT_PORT);								//	read the port number
	HANDLE hPort;

	if ((hPort = port_open(make_port_string(iPort), m_iBaudRate)) == NULL)
	{
		return;
	}

	if (bs_enable_beacon(hPort, false) != 0) 
	{
		port_close(hPort);	
		return;
	}

	if (port_close(hPort) != 0)
	{
		return;
	}
}
