/*********************
*	array.h
*	DynamicBuffer is a simple array class that allows you to create
*   a c-style array at runtime and have it clean up automaticly instead
*   of having to new/delete an array
*********************/
#ifndef	NODE_H
#define	NODE_H


template <class T>
class DynamicBuffer
{
public:
	DynamicBuffer(size_t size)
	{
		_buffer = new T[size];
		
		//zero the buffer
		::ZeroMemory(_buffer, (size)*sizeof(T));
	}
	~DynamicBuffer(){ delete[] _buffer; }
	
	T* GetBuffer(){ return _buffer; }
	operator T*() { return GetBuffer(); }
	//T& operator[](size_t pos){ return buffer[pos]; }

private:
	T* _buffer;
};

//A string buffer and a byte buffer
typedef DynamicBuffer<unsigned char> ByteBuffer;


#endif //end NODE_H